;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Kscope by Zack Xavier Haquer
; From Time Designs v3n1 p13
;===============================

@CHadd=4016
@Seed=4032
@GetHLDE=1305
@Break1=0F46
@DFile=400C
@LastK=4025

ORG 4084

@Kscope
	LD DE,4137		;Start of chrs to use-1 
@Loop
	INC DE 
	LD A,(DE) 		;Get chr
	CP 76			;End of data?
	JR Z Kscope		;Yes, restart
	LD (CHadd),DE		;Set CHadd
;Start of Randomizer
	LD DE,004B 		;75
	LD BC,(Seed)		;Get Seed
	INC BC 
	LD H,D 
	LD L,B 
	CALL GetHLDE+4		;HL=HL*DE
	PUSH HL 
	LD H,D 
	LD L,C 
	CALL GetHLDE+4		;HL=HL*DE
	POP BC 
	LD A,H 
	ADD A,C 
	JR NC +1
	INC B 
	LD H,A 
	LD A,L 
	SUB B 
	JR NC +1
	DEC H 
	LD L,A 
	DEC HL 
	LD (Seed),HL		;Set Seed
;End of Randomizer
	LD B,L 
	LD C,H 
	SRL C 
	SRL C 
	SRL C 
	SRL C 
	LD B,0C 
	CP B 
	JR C +3
	SUB B 
	JR -6
	LD B,A 
	PUSH BC 
	CALL East		;X=16+C
	CALL South		;Y=12+B
	CALL PrintA		;PRINT AT Y,X;A$
	POP BC 
	PUSH BC 
	CALL East		;X=16+C
	CALL North		;Y=11-B
	CALL PrintA		;PRINT AT Y,X;A$
	POP BC 
	PUSH BC 
	CALL West		;X=15-C
	CALL South		;Y=12-B
	CALL PrintA		;PRINT AT Y,X;A$
	POP BC 
	CALL West		;X=15-C
	CALL North		;Y=11-B
	CALL PrintA		;PRINT AT Y,X;A$
	LD A,(LastK)		;Get keyboard status
	CP FF			;Key pressed?
	RET NZ			;Return if keypress
	JR Loop
;==========================
@East				;X=16+C
	LD A,10 
	ADD A,C 
	LD C,A 
	RET
;==========================
@West				;X=15-C
	LD A,0F 
	SUB C 
	JR -7
;==========================
@South
	LD A,0C 		;Y=12+B
	ADD A,B 
	LD B,A 
	RET
;==========================
@North				;Y=11-B
	LD A,0B 
	SUB B 
	JR -7
;==========================
; PRINT AT Y,X;A$
;  B=Ycoord
;  C=Xcoord
;==========================
@PrintA				;PRINT AT Y,X;A$
	LD HL,(DFile)		;Get D-FILE
	INC HL 
	PUSH BC 
	LD C,00 
	SRL B 
	RR C 
	SRL B 
	RR C 
	SRL B 
	RR C 
	ADD HL,BC 
	POP BC 
	LD A,B 
	ADD A,C 
	LD B,00 
	LD C,A 
	ADD HL,BC 
	LD DE,(CHadd)		;Get CHadd
	LD A,(DE) 
	RES 6,A 
	LD (HL),A 
	RET
;==========================